package sun.awt.windows;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import sun.awt.SunGraphicsCallback;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.peer.PanelPeer;

class WPanelPeer extends WCanvasPeer implements PanelPeer
{
    Insets insets_;
    
    @Override
    public void paint(Graphics g) {
        super.paint(g);
        SunGraphicsCallback.PaintHeavyweightComponentsCallback.getInstance().runComponents(((Container)this.target).getComponents(), g, 3);
    }
    
    @Override
    public void print(Graphics g) {
        super.print(g);
        SunGraphicsCallback.PrintHeavyweightComponentsCallback.getInstance().runComponents(((Container)this.target).getComponents(), g, 3);
    }
    
    @Override
    public Insets getInsets() {
        return this.insets_;
    }
    
    private static native void initIDs();
    
    WPanelPeer(Component component) {
        super(component);
    }
    
    @Override
    void initialize() {
        super.initialize();
        this.insets_ = new Insets(0, 0, 0, 0);
        if (((Component)this.target).getBackground() == null) {
            Color defaultColor = WColor.getDefaultColor(1);
            ((Component)this.target).setBackground(defaultColor);
            this.setBackground(defaultColor);
        }
        if (((Component)this.target).getForeground() == null) {
            Color defaultColor2 = WColor.getDefaultColor(2);
            ((Component)this.target).setForeground(defaultColor2);
            this.setForeground(defaultColor2);
        }
    }
    
    public Insets insets() {
        return this.getInsets();
    }
    
    static {
        initIDs();
    }
}
